#include <stdio.h>
#include <string.h>

float media(int *a, int n)
{
    if (n==1)
        return a[0];
    return ((n-1)*media(a,n-1)+a[n-1])/n;
}

void afisare_cifre(unsigned int n)
{
    if (n<10)
        printf("%d ",n);
    else
    {
        afisare_cifre(n/10);
        printf("%d ",n%10);
    }
}

int nr_biti_unu(int n)
{
    if (n==0)
        return 0;
    if (n<0)
        return 32-nr_biti_unu(~n);
    return (n%2)+nr_biti_unu(n>>1);
}

void oglinda(char *s)
{
    int ls = strlen(s);
    if (ls==0)
        puts("EROARE");
    else
        if (ls==1)
            puts(s);
        else
        {
            puts(s);
            oglinda(s+1);
            puts(s);
        }
}

int main()
{
    int a[]={10,20,15,17,14};
    int n=sizeof(a)/sizeof(*a);
    printf("%f\n", media(a,n));

    n=75642; // natural pozitiv
    afisare_cifre(n);
    printf("\n");

    n=-10;
    printf("%d\n", nr_biti_unu(n));

    oglinda("mara");
    oglinda("");

    return 0;
}
